/*
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/GLEventListener.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/GLAutoDrawable.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/GL2.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/glu/GLU.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/util/gl2/GLUT.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/awt/GLCanvas.html
*/

import com.jogamp.opengl.GLEventListener;
import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GL2;
import com.jogamp.opengl.glu.GLU;
import com.jogamp.opengl.util.gl2.GLUT;
import com.jogamp.opengl.awt.GLCanvas;

import javax.swing.JFrame;

public class BasicGL2EventListener1 implements GLEventListener
{
   @Override
   public void init(GLAutoDrawable drawable)
   {
      final GL2 gl = drawable.getGL().getGL2();
      // Add initialization code.
   }

   @Override
   public void display(GLAutoDrawable drawable)
   {
      final GL2 gl = drawable.getGL().getGL2();
      // Add drawing code.
   }

   @Override
   public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height)
   {
      // This is called after OpenGL's glViewport() function.
   }

   @Override
   public void dispose(GLAutoDrawable drawable)
   {
   }

   public static void main(String[] args)
   {
      // Get a capabilities object from a GL2 profile.
      final GLProfile glProfile = GLProfile.get(GLProfile.GL2);
      final GLCapabilities glCapabilities = new GLCapabilities(glProfile);

      // Use it to create a GLCanvas.
      final GLCanvas glDrawable = new GLCanvas(glCapabilities);
      glDrawable.setPreferredSize(new java.awt.Dimension(400, 400));

      // Connect the GLJPanel with our GLEventListener implementation.
      glDrawable.addGLEventListener( new BasicGL2EventListener1() );

      // Create a JFrame.
      final JFrame jFrame = new JFrame("Basic JOGL Program (using GLCanvas)");
      jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      // Add the GLCanvas to the JFrame.
      jFrame.getContentPane().add(glDrawable);
      jFrame.pack();
      jFrame.setLocationRelativeTo(null);
      jFrame.setVisible(true);
   }
}
