/*
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/GLEventListener.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/GLAutoDrawable.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/GL2.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/glu/GLU.html
https://jogamp.org/deployment/jogamp-current/javadoc/jogl/javadoc_jogl_spec/com/jogamp/opengl/util/gl2/GLUT.html
https://jogamp.org/deployment/jogamp-next/javadoc/jogl/javadoc/com/jogamp/newt/opengl/GLWindow.html
*/

import com.jogamp.opengl.GLEventListener;
import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GL2;
import com.jogamp.opengl.glu.GLU;
import com.jogamp.opengl.util.gl2.GLUT;
import com.jogamp.opengl.util.Animator;

import com.jogamp.newt.NewtFactory;
import com.jogamp.newt.Display;
import com.jogamp.newt.Screen;
import com.jogamp.newt.opengl.GLWindow;

public class BasicGL2EventListener3 implements GLEventListener
{
   @Override
   public void init(GLAutoDrawable drawable)
   {
      final GL2 gl = drawable.getGL().getGL2();
      // Add initialization code.
   }

   @Override
   public void display(GLAutoDrawable drawable)
   {
      final GL2 gl = drawable.getGL().getGL2();
      // Add drawing code.
   }

   @Override
   public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height)
   {
      // This is called after OpenGL's glViewport() function.
   }

   @Override
   public void dispose(GLAutoDrawable drawable)
   {
   }

   public static void main(String[] args)
   {
      // Get a capabilities object from a GL2 profile.
      final GLProfile glProfile = GLProfile.get(GLProfile.GL2);
      final GLCapabilities glCapabilities = new GLCapabilities(glProfile);

      // Use it to create a Newt window.
      final Display display = NewtFactory.createDisplay(null);
      final Screen screen = NewtFactory.createScreen(display, 0);
      final GLWindow glWindow = GLWindow.create(screen, glCapabilities);
      glWindow.setTitle("Basic JOGL Program (using Newt Window)");
      glWindow.setSize(400, 400);
      glWindow.setResizable(true);
      glWindow.setPosition(500, 300);
      glWindow.setUndecorated(false);
      glWindow.setAlwaysOnTop(false);
      glWindow.setFullscreen(false);
      glWindow.setPointerVisible(true);
      glWindow.confinePointer(false);
      glWindow.setVisible(true);

      // Connect the GLWindow with our GLEventListener implementation.
      glWindow.addGLEventListener( new BasicGL2EventListener3() );

      // Create an animation thread to keep the window open.
      final Animator animator = new Animator(glWindow);
      animator.start();
   }
}
